
function Layer() {
  this._winId = null;
  this._onloadCallbacks = [];
  this._position = "screen-bottom-right";
  this._absoluteX = null;
  this._absoluteY = null;
  
  this._relativeNode = null;
  this._relativeX = null;
  this._relativeY = null;
  
  this._width = 300;
  this._height = 150;
  this._x = 0;
  this._y = 0;
  
  this._sizeToContent = false;
  this._transparent = true;
  this._opacityEffect = false;
  
  this._hidden = true;
}

Layer.prototype.open = function (immediatlyShow, callback) {
  this._winId = "layer-"+Math.floor(Math.random()*1000000);
  var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                .getService(Components.interfaces.nsIWindowWatcher);
  
  var win = ww.getWindowByName(this._winId,null);
  if (win) win.close();
  
  /*
  var _self = this;
  ww.registerNotification({observe : function(aSubject, aTopic, aData) {
          var window = aSubject;
          if (aTopic=="domwindowopened") {
            window.addEventListener("load",function (){
                window.removeEventListener("load",arguments.callee,false);
                if (window.name!=_self._winId) return;
                _self._onOpen(window,immediatlyShow);
                if (callback)
                  callback.call(callback.__parent__.Notifications);
            }, false);
          } else if (aTopic=="domwindowclosed") {
            if (window.name!=_self._winId) return;
            ww.unregisterNotification(this);
            _self._onClose();
          }
        }
  });
  */
  
  var flags = "chrome=yes,titlebar=no";
  if (navigator.platform.indexOf('Mac')!=0 && !Components.classes["@mozilla.org/jsctypes;1"])
    flags += ",dependent=yes";
  if (!this._transparent || navigator.platform.indexOf('Mac')==0)
    flags += ",popup=yes";
  if (this._width>0)
    flags += ",width="+this._width;
  if (this._height>0)
    flags += ",height="+this._height;
  
  var win = ww.openWindow(window, "chrome://yoonosb/content/js/services/alerts/layer.xul",
                    this._winId, flags, null);
  var _self=this;
  win.addEventListener("load",function () {
      win.removeEventListener("load",arguments.callee,false);
      // Set the title, used by jsctypes code!
      win.document.documentElement.setAttribute("title",_self._winId);
      window.setTimeout(wait,0);
  },false);
  
      function wait() {

        try {
          win.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
            .getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShell)
            .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
            .treeOwner
            .QueryInterface(Components.interfaces.nsIBaseWindow);
        } catch(e) {
          return window.setTimeout(wait,1000);
        }
        
        _self._onOpen(win,immediatlyShow);
        if (callback)
          callback();
      }
}

Layer.prototype._nativeShow = function () {
  try {
    this._baseWin.enabled = true;
    if (Components.classes["@mozilla.org/jsctypes;1"]) {
      Components.utils.import("resource://gre/modules/ctypes.jsm");
      var lib = ctypes.open("user32.dll");
      var findWindow = lib.declare("FindWindowW",
                                     ctypes.stdcall_abi,
                                     ctypes.int32_t,
                                     ctypes.ustring,
                                     ctypes.ustring);
      var getWindowLong = lib.declare("GetWindowLongW",
                                     ctypes.stdcall_abi,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t);
      var showWindow = lib.declare("ShowWindow",
                                     ctypes.stdcall_abi,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t);
      var setWindowLong = lib.declare("SetWindowLongW",
                                     ctypes.stdcall_abi,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t);
      var setWindowPos = lib.declare("SetWindowPos",
                                     ctypes.stdcall_abi,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t);
      var GWL_EXSTYLE = -20;
      var WS_EX_APPWINDOW = 262144;
      var WS_EX_NOACTIVATE = 0x8000000;
      var WS_EX_TOOLWINDOW = 128;
      var SW_HIDE=0;
      var SW_SHOW=5;
      var SW_SHOWNORMAL = 1;
      var SW_SHOWNOACTIVATE = 4;
      var SWP_NOSIZE = 1;
      var SWP_NOMOVE = 2;
      var SWP_NOACTIVATE = 16;
      var SWP_SHOWWINDOW = 64;
      var HWND_NOTOPMOST = -2;
      var HWND_TOPMOST = -1;
      
      var layer_win = findWindow("MozillaUIWindowClass", this._winId);
      
      var currentstyle = getWindowLong(layer_win,GWL_EXSTYLE);
      if ( (currentstyle | WS_EX_TOOLWINDOW) != currentstyle ) {
        // Need to encapsulate setWindowLong call by hide/show, in order to just work.
        showWindow(layer_win,SW_HIDE);
        
        // remove from taskbar
        setWindowLong(layer_win,GWL_EXSTYLE, currentstyle | WS_EX_TOOLWINDOW );
        
        showWindow(layer_win,SW_SHOWNOACTIVATE);
      }
      // Set topmost window
      
      setWindowPos(layer_win, HWND_TOPMOST, 0, 0, 0, 0, SWP_SHOWWINDOW|SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
    } else {
      // Do it only after changing enabled/visibility,
      // because mozilla API reset topmost flags ...
      var yoonoXPCOM = Components.classes["@yoono.com/windows;1"]
                    .getService(Components.interfaces.nsIYoono);
      yoonoXPCOM.makeTopmost(this._baseWin);
    }
  } catch(e) {
    YServices.log.exception(e);
    this._baseWin.enabled = true;
    this._baseWin.visibility = true;
  }
}

Layer.prototype._nativeHide = function () {
  try {
    if (Components.classes["@mozilla.org/jsctypes;1"]) {
      Components.utils.import("resource://gre/modules/ctypes.jsm");
      var lib = ctypes.open("user32.dll");
      var findWindow = lib.declare("FindWindowW",
                                     ctypes.stdcall_abi,
                                     ctypes.int32_t,
                                     ctypes.ustring,
                                     ctypes.ustring);
      var setWindowPos = lib.declare("SetWindowPos",
                                     ctypes.stdcall_abi,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t,
                                     ctypes.int32_t);
      var SWP_HIDEWINDOW = 128;
      var SWP_NOZORDER = 4;
      var SWP_NOSIZE = 1;
      var SWP_NOMOVE = 2;
      var SWP_NOACTIVATE = 16;
      var layer_win = findWindow("MozillaUIWindowClass", this._winId);
      setWindowPos(layer_win, 0, 0, 0, 0, 0, SWP_HIDEWINDOW | SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER );
    } else {
      // Do it only after changing enabled/visibility,
      // because mozilla API reset topmost flags ...
      var yoonoXPCOM = Components.classes["@yoono.com/windows;1"]
                    .getService(Components.interfaces.nsIYoono);
      yoonoXPCOM.hide2(this._baseWin);
    }
    
    
  } catch(e) {
    YServices.log.exception(e);
    this._baseWin.visibility = false;
    this._baseWin.enabled = false;
  }
}

Layer.prototype._opacityShowEffect = function () {
  var o = 0.2;
  var steps=0;
  var elt = this._win.document.documentElement;
  elt.style.opacity = o;
  var interval = window.setInterval(function () {
    elt.style.opacity = o;
    var acc=Math.sqrt(steps++)*0.07;
    acc=Math.max(0.01,acc);
    o+=acc;
    if (o>=1) {
      elt.style.opacity = 1;
      window.clearInterval(interval);
    }
  }, 50);
}

Layer.prototype.show = function (callback) {
  if (!this._win) {
    this.open(true,callback);
  } else {
    if (this._hidden) {
      if (this._opacityEffect) {
        var elt = this._win.document.documentElement;
        elt.style.opacity = 0;
      }
      this._hidden = false;
      this._nativeShow();
      if (this._opacityEffect) {
        this._opacityShowEffect();
      }
    }
    if (callback)
      callback();
  }
}

Layer.prototype.hide = function () {
  if (!this._win) return;
  if (this._opacityEffect) {
    var o = 1;
    var elt = this._win.document.documentElement;
    var _self = this;
    var steps = 0;
    var interval = window.setInterval(function () {
      elt.style.opacity = o;
      var acc=Math.sqrt(steps++)*0.06;
      acc=Math.max(0.01,acc);
      o-=acc;
      if (o<=0.1) {
        elt.style.opacity = 0.1;
        window.clearInterval(interval);
        _self._hidden = true;
        _self._nativeHide();
      }
    }, 40);
    
  } else {
    this._hidden = true;
    this._nativeHide();
  }
}

Layer.prototype.close = function () {
  if (!this._win) return;
  this._win.close();
}

Layer.prototype._onOpen = function (win,immediatlyShow) {
  this._win = win;
  this._baseWin = win.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                                        .getInterface(Components.interfaces.nsIWebNavigation)
                                        .QueryInterface(Components.interfaces.nsIDocShell)
                                        .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                                        .treeOwner
                                        .QueryInterface(Components.interfaces.nsIBaseWindow);
  this._baseWin.enabled = false;
  //this._baseWin.visibility = false;
  

  /*
  var xulwin = win.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
    .getInterface(Components.interfaces.nsIWebNavigation)
    .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
    .treeOwner
    .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
    .getInterface(Components.interfaces.nsIXULWindow);
  
  xulwin.zLevel = xulwin.highestZ;
  */
  
  if (!immediatlyShow) {
    this._nativeHide();
    this._hidden = true;
  } else {
    this._hidden = false;
    this._nativeShow();
  }
  
  if (navigator.platform.indexOf('Mac')==0)
    this._win.document.documentElement.className += " mac";
  
  if (!this._opacityEffect) {
    this._win.document.documentElement.style.opacity = "1";
  } else if (immediatlyShow) {
    this._opacityShowEffect();
  }
  
  for(var i=0; i<this._onloadCallbacks.length; i++) {
    try {
      this._onloadCallbacks[i].call(this);
    } catch(e) {
      YServices.log.exception(e);
    }
  }
  this._onloadCallbacks = [];
  this._updateSizeAndPosition();
}

Layer.prototype._onClose = function () {
  this._win = null;
  this._onloadCallbacks = [];
}

Layer.prototype.getScreen = function () {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
  var topmostwin = wm.getMostRecentWindow("navigator:browser");

  var sm = Components.classes["@mozilla.org/gfx/screenmanager;1"].getService(Components.interfaces.nsIScreenManager);
  var sc = sm.screenForRect(topmostwin.screenX, topmostwin.screenY, 10, 10);
  var left = {},top = {},width = {},height = {};
  sc.GetAvailRect(left, top, width, height);

  return { availWidth : width.value, availLeft : left.value,
    availTop : top.value, availHeight: height.value };
}

Layer.prototype.resize = function (width, height) {
  this._width = width;
  this._height = height;
  this._updateSizeAndPosition();
}

Layer.prototype.move = function (position, x, y, relativeNode) {
  if (position.match(/screen-/)) {
    var screenPosition = position.replace(/screen-/,"");
    if (["top-left","top-right","bottom-left","bottom-right","absolute","center"].indexOf(screenPosition)==-1)
      throw new Error("Bad position : screen-"+screenPosition+"\n");
    this._relativeX = x?x:0;
    this._relativeY = y?y:0;
  } else if (position.match(/relative-/)) {
    var relativePosition = position.replace(/relative-/,"");
    if (["before","after","top","bottom"].indexOf(relativePosition)==-1)
      throw new Error("Bad position : relative-"+relativePosition+"\n");
    this._relativeNode = relativeNode;
    this._relativeX = x?x:0;
    this._relativeY = y?y:0;
  } else {
    throw new Error("Bad position : "+position);
  }
  this._position = position;
  this._updateSizeAndPosition();
}

Layer.prototype._updateSizeAndPosition = function () {
  if (!this._win) return;
  
  var width=this._width;
  if (width<0) {
    width = this._win.document.documentElement.scrollWidth;
    width = this._win.document.getElementById("layer-content").scrollWidth;
  }
  var height=this._height;
  if (height<0) {
    height = this._win.document.getElementById("alert-top-box").scrollHeight;
    /*
    YServices.log.error("height : "+height);
    YServices.log.error("scrollheight : "+this._win.document.documentElement.scrollHeight);
    YServices.log.error("clientheight : "+this._win.document.documentElement.clientHeight);
    YServices.log.error("c scrollheight : "+this._win.document.getElementById("alert-top-box").scrollHeight);
    YServices.log.error("c clientheight : "+this._win.document.getElementById("alert-top-box").clientHeight);
    */
  }

  if (this._width<0) {
    this._win.document.documentElement.style.maxWidth="";
    this._win.document.documentElement.style.width="";
  } else {
    this._win.document.documentElement.style.maxWidth=width+"px";
    this._win.document.documentElement.style.width=width+"px";
  }
  if (this._height<0) {
    this._win.document.documentElement.style.maxHeight=height+"px";
    this._win.document.documentElement.style.height=height+"px";
  } else {
    this._win.document.documentElement.style.maxHeight=height+"px";
    this._win.document.documentElement.style.height=height+"px";
  }
  
  //this._win.sizeToContent();
  this._win.innerWidth = width;
  this._win.innerHeight = height;
  width = this._win.innerWidth;
  height = this._win.innerHeight;
  //YServices.log.error("after sizetocontent : "+width+"x"+height);
  
  if (this._position.match(/screen-/)) {
    var position = this._position.replace(/screen-/,"");
    var screen = this.getScreen();
    if (position=="top-left" || position=="absolute") {
      this._x = screen.availLeft;
      this._y = screen.availTop;
    } else if (position=="top-right") {
      this._x = screen.availLeft + screen.availWidth - width;
      this._y = screen.availTop;
    } else if (position=="bottom-left") {
      this._x = screen.availLeft;
      this._y = screen.availTop + screen.availHeight - height;
    } else if (position=="bottom-right") {
      this._x = screen.availLeft + screen.availWidth - width;
      this._y = screen.availTop + screen.availHeight - height;
    } else if (position=="center") {
      this._x = screen.availLeft + (screen.availWidth/2) - (width/2);
      this._y = screen.availTop + (screen.availHeight/2) - (height/2);
    }
    this._x += this._relativeX;
    this._y += this._relativeY;
    
  } else if (this._position.match(/relative/)) {
    var position = this._position.replace(/relative-/,"");
    var bo = this.getBoxobject(this._relativeNode);
    if (position=="before") {
      this._x = bo.screenX + this._relativeX - width;
      this._y = bo.screenY + this._relativeY + (this._relativeNode.clientHeight/2) - (height/2);
    } else if (position=="after") {
      this._x = bo.screenX + this._relativeX + this._relativeNode.clientWidth;
      this._y = bo.screenY + this._relativeY + (this._relativeNode.clientHeight/2) - (height/2);
    } else if (position=="top") {
      this._x = bo.screenX + this._relativeX + (this._relativeNode.clientWidth/2) - (width/2);
      this._y = bo.screenY + this._relativeY - height;
    } else if (position=="bottom") {
      this._x = bo.screenX + this._relativeX + (this._relativeNode.clientWidth/2) - (width/2);
      this._y = bo.screenY + this._relativeY + this._relativeNode.clientHeight;
    }
    
  }
  this._win.screenX = this._x;
  this._win.screenY = this._y;
}

Layer.prototype.getBoxobject = function(elt) {
  var boxobject = null;
  // html case
  if (elt.ownerDocument && elt.ownerDocument.getBoxObjectFor)
    boxobject=elt.ownerDocument.getBoxObjectFor(elt);
  // xul case
  if (!boxobject)
    boxobject=elt.boxObject;
  // problem case
  if (!boxobject) {
    dump("unable to get easily boxobject : "+elt.tagName);
    var docshell = elt.QueryInterface(Ci.nsIInterfaceRequestor)
                         .getInterface(Ci.nsIWebNavigation)
                         .QueryInterface(Ci.nsIDocShell);
    if (!docshell.chromeEventHandler)
      inspect(docshell);
    var boxobject = docshell.chromeEventHandler.boxObject;
    if (boxobject) {
      dump("getboxobject with doshell xul : "+docshell.chromeEventHandler.tagName);
    }
    if (!boxobject) {
      dump("get boxobject with docshell html : "+docshell.chromeEventHandler.tagName+"/"+docshell.chromeEventHandler.ownerDocument.tagName);
      boxobject = docshell.chromeEventHandler.ownerDocument.getBoxObjectFor(docshell.chromeEventHandler);
    }
    if (!boxobject)
      dump("Unable to get boxobject!!!");
  }
  return boxobject;
}

Layer.prototype.setStyleText = function (css) {
  if (!this._win) {
    this._onloadCallbacks.push(function () {
      this.setStyleText(css);
    });
    return;
  }
  this._win.document.getElementById("styles").innerHTML=css;
}

Layer.prototype.setContent = function (html) {
  if (!this._win) {
    this._onloadCallbacks.push(function () {
      this.setContent(html);
    });
    return;
  }
  this._win.document.getElementById("layer-content").innerHTML=html;
}

Layer.prototype.getContent = function () {
  if (!this._win) return null;
  return this._win.document.getElementById("layer-content");
}

Layer.prototype.getElementById = function (id) {
  if (!this._win) return null;
  return this._win.document.getElementById(id);
}

Layer.prototype.setOpacityEffet = function (enabled) {
  if (navigator.platform.indexOf('Mac')==0) return;
  this._opacityEffect = enabled;
}

Layer.closeAll = function () {
  
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                      .getService(Components.interfaces.nsIWindowMediator);
  var enumerator = wm.getEnumerator("yoono:layer");
  while(enumerator.hasMoreElements()) {
    var win = enumerator.getNext();
    win.close();
  }
  
}
